package exampler.fitlibrary;

import fitlibrary.parse.Table;

public class AndFilterFixtureTests extends FilterFixtureTestCase {



    public void testAndFixtureWithCategories() {
        Table input = makeTable("exampler.fitlibrary.CF", new String[][]{
                { "categoryA", "Ae0, Ae1, Ae2",   "Ac0" },
                { "categoryB", "Be0,Be1",         "Bc0,Bc1" },
                { "categoryC", "Ce0",             "Cc0"} } );

        String[][] expected = new String[][] {
                { "exampler.fitlibrary.CF"},
                { "categoryA", "categoryB", "categoryC", "result\\(\\)" },
                { "Ac0", "Be0", "Ce0", "false"},
                { "Ae0", "Bc0", "Ce0", "false"},
                { "Ae1", "Bc1", "Ce0", "false"},
                { "Ae2", "Be1", "Cc0", "false"},
                { "Ae0", "Be0", "Ce0", "true"},
                { "Ae1", "Be1", "Ce0", "true"},
                { "Ae2", "Be0", "Ce0", "true"}};

        BooleanFilterFixture fixture = new AndFilterFixture();
        fixture.doTearDown(input);

        Table resultTable = new Table(input.parse.more);
        assertEqualTables(expected, resultTable);
    }

    public void testAndFixtureWithoutCategories() {
        Table input = makeTable("exampler.fitlibrary.CF", new String[][]{
                { "booleanA"  },
                { "booleanB"  } } );

        String[][] expected = new String[][] {
                { "exampler.fitlibrary.CF"},
                { "booleanA", "booleanB", "result\\(\\)" },
                { "false", "true",   "false"},
                { "true",  "false",  "false"},
                { "true",  "true",   "true"}};

        BooleanFilterFixture fixture = new AndFilterFixture();
        fixture.doTearDown(input);

        Table resultTable = new Table(input.parse.more);
        assertEqualTables(expected, resultTable);
    }

}
