package exampler.fitlibrary;

import fitlibrary.parse.Table;

public class OrFilterFixureTests extends FilterFixtureTestCase {
    public void testOrFixtureWithExplicitCategories() {
        Table input = makeTable("exampler.fitlibrary.OR", new String[][]{
                { "categoryA", "Ae0, Ae1, Ae2",   "Ac0" },
                { "categoryB", "Be0,Be1",         "Bc0,Bc1" },
                { "categoryC", "Ce0",             "Cc0"} } );

        String[][] expected = new String[][] {
                { "exampler.fitlibrary.OR"},
                { "categoryA", "categoryB", "categoryC", "result\\(\\)" },

                { "Ae0", "Bc0", "Cc0", "true"},
                { "Ae1", "Bc1", "Cc0", "true"},
                { "Ae2", "Bc0", "Cc0", "true"},
                { "Ac0", "Be0", "Cc0", "true"},
                { "Ac0", "Be1", "Cc0", "true"},
                { "Ac0", "Bc1", "Ce0", "true"},

                { "Ac0", "Bc0", "Cc0", "false"},
                { "Ac0", "Bc1", "Cc0", "false"}};

        BooleanFilterFixture fixture = new OrFilterFixture();
        fixture.doTearDown(input);

        Table resultTable = new Table(input.parse.more);
        assertEqualTables(expected, resultTable);
    }

    public void testOrFixtureWithAnImplicitCategory() {
        Table input = makeTable("exampler.fitlibrary.OR", new String[][]{
                { "categoryA", "Ae0, Ae1, Ae2",   "Ac0, Ac1" },
                { "categoryB" },
                { "categoryC" } } );

        String[][] expected = new String[][] {
                { "exampler.fitlibrary.OR"},
                { "categoryA", "categoryB", "categoryC", "result\\(\\)" },

                { "Ae0", "false", "false", "true"},
                { "Ae1", "false", "false", "true"},
                { "Ae2", "false", "false", "true"},
                { "Ac0", "true",  "false", "true"},
                { "Ac1", "false", "true",  "true"},

                { "Ac0", "false", "false", "false"},
                { "Ac1", "false", "false", "false"}};

        BooleanFilterFixture fixture = new OrFilterFixture();
        fixture.doTearDown(input);

        Table resultTable = new Table(input.parse.more);
        assertEqualTables(expected, resultTable);
    }

}
